package cs108;

import java.util.Iterator;

public abstract class SAbstractList<E> implements SList<E> {
    @Override
    public boolean isEmpty() {
        return size() == 0;
    }

    @Override
    public boolean contains(E e) {
        for (E e1: this) {
            if (e1.equals(e))
                return true;
        }
        return false;
    }

    @Override
    public String toString() {
        StringBuilder b = new StringBuilder("[");
        Iterator<E> i = iterator();
        while (i.hasNext()) {
            b.append(i.next())
            .append(i.hasNext() ? ", " : "]");
        }
        return b.toString();
    }

    protected final int checkElementIndex(int i) {
        if (! (0 <= i && i < size()))
            throw new IndexOutOfBoundsException(String.format("invalid index %d (should be in [0,%d])", i, size() - 1));
        return i;
    }

    protected final int checkPositionIndex(int i) {
        if (! (0 <= i && i <= size()))
            throw new IndexOutOfBoundsException(String.format("invalid index %d (should be in [0,%d])", i, size()));
        return i;
    }
}
